/*
 *  Example of using setting shared memory in user-space
 */

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>

#define MEMORY_OFFSET 250 * 0x100000

struct shared_mem_struct
{
	float alphai;
	char ready;
};
int memfd;

struct shared_mem_struct* shared_mem;

int main()
{
	char input[40];

	memfd = open("/dev/mem", O_RDWR);
	if (memfd)
	{
	  shared_mem = (struct shared_mem_struct*) mmap(0,
	  	sizeof(struct shared_mem_struct),
	  	PROT_READ | PROT_WRITE, MAP_FILE | MAP_SHARED, memfd, MEMORY_OFFSET);
	  if (shared_mem != NULL)
	  {  	
		  do
			{
				scanf("%s", input);
				shared_mem->alphai = atof(input);
				shared_mem->ready = 1;
			}
			while (strcmp(input, "end") != 0);
		}
		else
			printf("Failed to map memory\n");
		close (memfd);
	}
	else
		printf("Failed to open memory device file\n");
	
	return 0;
}